<!DOCTYPE html>
<html lang="en">
<head>
  <title>67.S10</title>
  <meta charset="utf-8">
  <meta name="viewport" content="width=device-width, initial-scale=1">
  <link rel="stylesheet" href="https://maxcdn.bootstrapcdn.com/bootstrap/4.5.2/css/bootstrap.min.css">
  <script src="https://ajax.googleapis.com/ajax/libs/jquery/3.6.0/jquery.min.js"></script>
  <script src="https://maxcdn.bootstrapcdn.com/bootstrap/4.5.2/js/bootstrap.min.js"></script>

  <!-- Import Datatable sau jquery -->
  <!-- Import them style bootstrap cho datatable -->
  <link rel="stylesheet" href="https://cdn.datatables.net/1.10.24/css/dataTables.bootstrap4.min.css">
  <script src="https://cdn.datatables.net/1.10.24/js/jquery.dataTables.min.js"></script>
  <script src="https://cdn.datatables.net/1.10.24/js/dataTables.bootstrap4.min.js"></script>
   <!-- Font Awesome -->
  <link rel="stylesheet" href="https://cdnjs.cloudflare.com/ajax/libs/font-awesome/6.4.0/css/all.min.css">
</head>
<body>

<div class="container">
  <h2 style="text-align: center;">Quản trị Voucher</h2>
	<div class="jumbotron container">
	  <div class="row form-group">
		<div class="col-sm-3">
		  <label for="voucher-code">Mã Voucher</label>
		</div>
		<div class="col-sm-9">
		  <input type="text" id="input-voucher-code" name="vouchercodes" placeholder="Voucher code"
			class="form-control">
		</div>
	  </div>
	  <div class="row form-group">
		<div class="col-sm-3">
		  <label for="discount">Phần trăm giảm giá</label>
		</div>
		<div class="col-sm-9">
		  <input type="number" id="input-discount" name="discount" placeholder="Discount" class="form-control">
		</div>
	  </div>
	  <div class="row form-group">
		<div class="col-sm-3">
		  <label for="note">Ghi chú</label>
		</div>
		<div class="col-sm-9">
		  <input id="input-note" name="note" placeholder="Note" class="form-control">
		</div>
	  </div>
	  <div class="row form-group">
		<div class="col-sm-3">
		  <label for="createDate">Ngày Tạo</label>
		</div>
		<div class="col-sm-9">
		  <input type="date" date-date="" date-date-format="MM/DD/YYYY" id="input-createDate" name="createDate" placeholder="Create Date" class="form-control">
		</div>
	  </div>
	  <div class="row form-group">
		<div class="col-sm-3">
		  <label for="updateDate">Ngày sửa</label>
		</div>
		<div class="col-sm-9">
		  <input type="date" date-date="" date-date-format="dd/mm/yyyy" id="input-updateDate" name="updateDate" placeholder="Update Date" class="form-control">
		</div>
	  </div>
	<div class="col-sm-12" style="margin-left: 255px"	>
	  	<div class="row">
			<div class="col-sm-2 ">
				<button id="create_data" class="btn btn-success form-control">Create</button>
			</div>
			<div class="col-sm-2 ">
				<button id="update_data" class="btn btn-info form-control">Update</button>
			</div>
			<div class="col-sm-2">
				<button id="delete_data" class="btn btn-warning form-control">Delete</button>
			</div>
			<div class="col-sm-2 ">
				<button id="delete_all_data" class="btn btn-danger form-control">Delete All</button>
			</div>
	  	</div>
	</div>
	</div>
  <table class="table table-bordered table-striped table-hover" id="voucher-table">
    <thead>
      <tr>
        <th>STT</th>
        <th>Mã giảm giá</th>
        <th>Phần trăm giảm giá</th>
        <th>Ghi Chú</th>
        <th>Ngày tạo</th>
        <th>Ngày cập nhật</th>
		
      </tr>
	  
  </table>
</div>
<script>

/*** REGION 1 - Global variables - Vùng khai báo biến, hằng số, tham số TOÀN CỤC */

	var gNameCol = ["id", "maVoucher", "phanTramGiamGia", "ghiChu", "ngayTao", "ngayCapNhat"]

	const gCOL_STT = 0;
	const gCOL_MA_VOUCHER = 1;
	const gCOL_PHANTRAM_GIAM_GIA = 2;
	const gCOL_GHI_CHU = 3;
	const gCOL_NGAY_TAO = 4;
	const gCOL_NGAY_CAP_NHAT = 5;
	
	var gRowData;
	var gRowId;
	var gStt = 0; 
	var gVoucherTable = $("#voucher-table").DataTable({
			columns: [
				{data: gNameCol[gCOL_STT]},
				{data: gNameCol[gCOL_MA_VOUCHER]},
				{data: gNameCol[gCOL_PHANTRAM_GIAM_GIA]},
				{data: gNameCol[gCOL_GHI_CHU]},
				{data: gNameCol[gCOL_NGAY_TAO]},
				{data: gNameCol[gCOL_NGAY_CAP_NHAT]},
				
			],
		})

 /*** REGION 2 - Vùng gán / thực thi sự kiện cho các elements */

 
 $(document).ready(function(){
		
	//load data to the table
	callAPIGetData();

	//add event of Edit Button click
	$("#voucher-table").on("click", "tr", function(){
		eventOnRowClick(this);
	})

	//add event for Update Button click
	$("#update_data").on('click', function(){
		onBtnCreateClick();
	})

})


 /*** REGION 3 - Event handlers - Vùng khai báo các hàm xử lý sự kiện */

function eventOnRowClick(paramRow){
	gRowData = getRowData(paramRow);
	gRowId = gRowData.id;
	console.log("Row_Id: " + gRowId);
	

	loadDataToForm(gRowData);
}

function onBtnCreateClick(){

	//create object for data update
	var vUpdateObj = {
		maVoucher:"",
		phanTramGiamGia:"",
		ghiChu:"",
		ngayTao:"",
		ngayCapNhat:"",
	};

	//get data from the form
	getDataFromTheForm(vUpdateObj);
	console.log(vUpdateObj);

	//validate the data
	var vValidRes = validateData(vUpdateObj);
	
	//call API to update the data to server
	if (vValidRes){
		console.log("ID " + gRowId);
		callApiUpdateData(vUpdateObj);
	}
}


 /*** REGION 4 - Common funtions - Vùng khai báo hàm dùng chung trong toàn bộ chương trình*/

function callAPIGetData (){
	$.ajax({
			url: "http://localhost:8081/api/vouchers",
			type: "GET",
			dataType: "json",
			success: function(res){
				console.log(res);
				reLoadTable(res);
			},
			error: function(err){
				console.log(err.response);
			}
		})
 }

function reLoadTable(paramData){
	gVoucherTable.clear();
	gVoucherTable.rows.add(paramData);
	gVoucherTable.draw();
}

function getRowData(paramData){
	//var vTableRow = $(paramButton).parents("tr");
	var vRowData = gVoucherTable.row(paramData).data();
	console.log("Row_Data:" + vRowData);

	return vRowData;
}

function loadDataToForm(paramRowData){
	$("#input-voucher-code").val(paramRowData.maVoucher);
	$("#input-discount").val(paramRowData.phanTramGiamGia);
	$("#input-note").val(paramRowData.ghiChu);
	$("#input-createDate").val(paramRowData.ngayTao);
	$("#input-updateDate").val(paramRowData.ngayCapNhat);
}

function getDataFromTheForm(paramData){
	paramData.maVoucher = $("#input-voucher-code").val();
	paramData.phanTramGiamGia = $("#input-discount").val();
	paramData.ghiChu = $("#input-note").val();
	paramData.ngayTao = $("#input-createDate").val();
	paramData.ngayCapNhat = $("#input-updateDate").val();
}
	
function validateData(paramValid){
	if (paramValid.maVoucher == ""){
		alert("Voucher code is empty !!!")
	}
	if (paramValid.phanTramGiamGia == ""){
		alert("Discount is empty !!!")
	}
	if (paramValid.ghiChu == ""){
		alert("Note is empty !!!")
	}
	
	return true;
}

function callApiUpdateData(paramData){
	$.ajax({
			url: "http://localhost:8081/api/vouchers/" + gRowId,
			type: "PUT",
			contentType: "application/json",
			data: JSON.stringify(paramData),
			success: function(res){
				console.log(res);
				callAPIGetData();
				clearTheForm();

			},
			error: function(err){
				console.log(err.response);
			}
		})
}

function clearTheForm(){
	$("#input-voucher-code").val("");
	$("#input-discount").val("");
	$("#input-note").val("");
	$("#input-createDate").val("");
	$("#input-updateDate").val("");
}

</script>
</body>
</html>
